// This file is generated by kconfig_compiler_kf5 from colorssettings.kcfg.
// All changes you do to this file will be lost.
#ifndef COLORSSETTINGS_H
#define COLORSSETTINGS_H

#include <qglobal.h>
#include <kconfigskeleton.h>
#include <QCoreApplication>
#include <QDebug>

class ColorsSettings : public KConfigSkeleton
{
  Q_OBJECT
  public:

    ColorsSettings( QObject *parent = nullptr );
    ~ColorsSettings() override;

    /**
      Set Color scheme name
    */
    void setColorScheme( const QString & v )
    {
      if (v != mColorScheme && !isColorSchemeImmutable()) {
        mColorScheme = v;
        Q_EMIT colorSchemeChanged();
      }
    }

    Q_PROPERTY(QString colorScheme READ colorScheme WRITE setColorScheme NOTIFY colorSchemeChanged)
    Q_PROPERTY(bool isColorSchemeImmutable READ isColorSchemeImmutable CONSTANT)
    /**
      Get Color scheme name
    */
    QString colorScheme() const
    {
      return mColorScheme;
    }

    /**
      Is Color scheme name Immutable
    */
    bool isColorSchemeImmutable() const
    {
      return isImmutable( QStringLiteral( "colorScheme" ) );
    }

    /**
      Get Color scheme name default value
    */
    QString defaultColorSchemeValue() const
    {
        return defaultColorSchemeValue_helper();
    }

    /**
      Set Accent color
    */
    void setAccentColor( const QColor & v )
    {
      if (v != mAccentColor && !isAccentColorImmutable()) {
        mAccentColor = v;
        Q_EMIT accentColorChanged();
      }
    }

    Q_PROPERTY(QColor accentColor READ accentColor WRITE setAccentColor NOTIFY accentColorChanged)
    Q_PROPERTY(bool isAccentColorImmutable READ isAccentColorImmutable CONSTANT)
    /**
      Get Accent color
    */
    QColor accentColor() const
    {
      return mAccentColor;
    }

    /**
      Is Accent color Immutable
    */
    bool isAccentColorImmutable() const
    {
      return isImmutable( QStringLiteral( "accentColor" ) );
    }

    /**
      Get Accent color default value
    */
    QColor defaultAccentColorValue() const
    {
        return defaultAccentColorValue_helper();
    }


    enum {
      signalColorSchemeChanged = 0x1,
      signalAccentColorChanged = 0x2
    };

  Q_SIGNALS:
    void colorSchemeChanged();

    void accentColorChanged();

  private:
    void itemChanged(quint64 flags);

  protected:

    // General
    QString mColorScheme;
    QString defaultColorSchemeValue_helper() const;
    QColor mAccentColor;
    QColor defaultAccentColorValue_helper() const;

  private:
};

#endif

